using RMYY_CallCenter_Api.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RMYY_CallCenter_Api.Dal
{
    /// <summary>
    /// 数据访问类:T_Dev_Operate
    /// </summary>
    public partial class T_Dev_Operate
    {
        public T_Dev_Operate()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Dev_Operate");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(RMYY_CallCenter_Api.Model.T_Dev_Operate model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Dev_Operate(");
            strSql.Append("F_WoId,F_DeviceName,F_NeedNum,F_GiveNum,F_RemainderNum,F_OutTime,F_DeviceCode,F_OptPerson,F_OptPersonName,F_OptPhon,F_Remark,F_State)");
            strSql.Append(" values (");
            strSql.Append("@F_WoId,@F_DeviceName,@F_NeedNum,@F_GiveNum,@F_RemainderNum,@F_OutTime,@F_DeviceCode,@F_OptPerson,@F_OptPersonName,@F_OptPhon,@F_Remark,@F_State)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WoId", SqlDbType.Int,4),
                    new SqlParameter("@F_DeviceName", SqlDbType.NVarChar,300),
                    new SqlParameter("@F_NeedNum", SqlDbType.Int,4),
                    new SqlParameter("@F_GiveNum", SqlDbType.Int,4),
                    new SqlParameter("@F_RemainderNum", SqlDbType.Int,4),
                    new SqlParameter("@F_OutTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DeviceCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_OptPerson", SqlDbType.VarChar,50),
                    new SqlParameter("@F_OptPersonName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_OptPhon", SqlDbType.VarChar,20),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_State", SqlDbType.Int,4)};
            parameters[0].Value = model.F_WoId;
            parameters[1].Value = model.F_DeviceName;
            parameters[2].Value = model.F_NeedNum;
            parameters[3].Value = model.F_GiveNum;
            parameters[4].Value = model.F_RemainderNum;
            parameters[5].Value = model.F_OutTime;
            parameters[6].Value = model.F_DeviceCode;
            parameters[7].Value = model.F_OptPerson;
            parameters[8].Value = model.F_OptPersonName;
            parameters[9].Value = model.F_OptPhon;
            parameters[10].Value = model.F_Remark;
            parameters[11].Value = model.F_State;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(RMYY_CallCenter_Api.Model.T_Dev_Operate model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Dev_Operate set ");
            strSql.Append("F_WoId=@F_WoId,");
            strSql.Append("F_DeviceName=@F_DeviceName,");
            strSql.Append("F_NeedNum=@F_NeedNum,");
            strSql.Append("F_GiveNum=@F_GiveNum,");
            strSql.Append("F_RemainderNum=@F_RemainderNum,");
            strSql.Append("F_OutTime=@F_OutTime,");
            strSql.Append("F_DeviceCode=@F_DeviceCode,");
            strSql.Append("F_OptPerson=@F_OptPerson,");
            strSql.Append("F_OptPersonName=@F_OptPersonName,");
            strSql.Append("F_OptPhon=@F_OptPhon,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_State=@F_State");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WoId", SqlDbType.Int,4),
                    new SqlParameter("@F_DeviceName", SqlDbType.NVarChar,300),
                    new SqlParameter("@F_NeedNum", SqlDbType.Int,4),
                    new SqlParameter("@F_GiveNum", SqlDbType.Int,4),
                    new SqlParameter("@F_RemainderNum", SqlDbType.Int,4),
                    new SqlParameter("@F_OutTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DeviceCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_OptPerson", SqlDbType.VarChar,50),
                    new SqlParameter("@F_OptPersonName", SqlDbType.VarChar,50),
                    new SqlParameter("@F_OptPhon", SqlDbType.VarChar,20),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_WoId;
            parameters[1].Value = model.F_DeviceName;
            parameters[2].Value = model.F_NeedNum;
            parameters[3].Value = model.F_GiveNum;
            parameters[4].Value = model.F_RemainderNum;
            parameters[5].Value = model.F_OutTime;
            parameters[6].Value = model.F_DeviceCode;
            parameters[7].Value = model.F_OptPerson;
            parameters[8].Value = model.F_OptPersonName;
            parameters[9].Value = model.F_OptPhon;
            parameters[10].Value = model.F_Remark;
            parameters[11].Value = model.F_State;
            parameters[12].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Dev_Operate ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Dev_Operate ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Dev_Operate GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_WoId,F_DeviceName,F_NeedNum,F_GiveNum,F_RemainderNum,F_OutTime,F_DeviceCode,F_OptPerson,F_OptPersonName,F_OptPhon,F_Remark,F_State from T_Dev_Operate ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            RMYY_CallCenter_Api.Model.T_Dev_Operate model = new RMYY_CallCenter_Api.Model.T_Dev_Operate();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Dev_Operate DataRowToModel(DataRow row)
        {
            RMYY_CallCenter_Api.Model.T_Dev_Operate model = new RMYY_CallCenter_Api.Model.T_Dev_Operate();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_WoId"] != null && row["F_WoId"].ToString() != "")
                {
                    model.F_WoId = int.Parse(row["F_WoId"].ToString());
                }
                if (row["F_DeviceName"] != null)
                {
                    model.F_DeviceName = row["F_DeviceName"].ToString();
                }
                if (row["F_NeedNum"] != null && row["F_NeedNum"].ToString() != "")
                {
                    model.F_NeedNum = int.Parse(row["F_NeedNum"].ToString());
                }
                if (row["F_GiveNum"] != null && row["F_GiveNum"].ToString() != "")
                {
                    model.F_GiveNum = int.Parse(row["F_GiveNum"].ToString());
                }
                if (row["F_RemainderNum"] != null && row["F_RemainderNum"].ToString() != "")
                {
                    model.F_RemainderNum = int.Parse(row["F_RemainderNum"].ToString());
                }
                if (row["F_OutTime"] != null && row["F_OutTime"].ToString() != "")
                {
                    model.F_OutTime = DateTime.Parse(row["F_OutTime"].ToString());
                }
                if (row["F_DeviceCode"] != null)
                {
                    model.F_DeviceCode = row["F_DeviceCode"].ToString();
                }
                if (row["F_OptPerson"] != null)
                {
                    model.F_OptPerson = row["F_OptPerson"].ToString();
                }
                if (row["F_OptPersonName"] != null)
                {
                    model.F_OptPersonName = row["F_OptPersonName"].ToString();
                }
                if (row["F_OptPhon"] != null)
                {
                    model.F_OptPhon = row["F_OptPhon"].ToString();
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_WoId,F_DeviceName,F_NeedNum,F_GiveNum,F_RemainderNum,F_OutTime,F_DeviceCode,F_OptPerson,F_OptPersonName,F_OptPhon,F_Remark,F_State ");
            strSql.Append(" FROM T_Dev_Operate ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_WoId,F_DeviceName,F_NeedNum,F_GiveNum,F_RemainderNum,F_OutTime,F_DeviceCode,F_OptPerson,F_OptPersonName,F_OptPhon,F_Remark,F_State ");
            strSql.Append(" FROM T_Dev_Operate ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Dev_Operate ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Dev_Operate T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Dev_Operate";
			parameters[1].Value = "F_Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
